indexing

	description: "eposix's MIME parser."

	standards: "Based on RFC 822, 2045, 2047 and 2616."

	implementation:
		"1. Not all recognized field names are parsed.%
		%   Should be easy to expand if you wish to do real message parsing.%
		%   That is not yet the case, everything about MIME messages%
		%   must be defined here and compiled in.%
		%2. Fields to add: Content-Type-Encoding; Content-Description%
		%3. What if no header, just empty line and body? Parsed ok?"

	known_bugs:
		"1. Dates with invalid time-zone get time-zone +0000."

	author: "Berend de Boer"
	date: "$Date: $"
	revision: "$Revision: $"

class

	EPX_MIME_PARSER


inherit

	EPX_MIME_SCANNER
		rename
			make as make_scanner
		redefine
			wrap
		end

	YY_PARSER_SKELETON
		rename
			parse as do_parse
		redefine
			make,
			report_error
		end

	EPX_MIME_PARAMETER_NAMES
		export
			{NONE} all
		end

	EPX_MIME_FIELD_NAMES
		export
			{NONE} all
		end

	STDC_CURRENT_PROCESS
		rename
			abort as abort_process
		export
			{NONE} all
		end


creation

	make,
	make_from_file,
	make_from_stream,
	make_from_file_descriptor



feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks is
			-- Create value stacks.
		do
		end

	yy_init_value_stacks is
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
			yyvsp8 := -1
			yyvsp9 := -1
			yyvsp10 := -1
			yyvsp11 := -1
			yyvsp12 := -1
			yyvsp13 := -1
			yyvsp14 := -1
			yyvsp15 := -1
			yyvsp16 := -1
			yyvsp17 := -1
			yyvsp18 := -1
			yyvsp19 := -1
		end

	yy_clear_value_stacks is
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			if yyvs1 /= Void then
				yyvs1.clear_all
			end
			if yyvs2 /= Void then
				yyvs2.clear_all
			end
			if yyvs3 /= Void then
				yyvs3.clear_all
			end
			if yyvs4 /= Void then
				yyvs4.clear_all
			end
			if yyvs5 /= Void then
				yyvs5.clear_all
			end
			if yyvs6 /= Void then
				yyvs6.clear_all
			end
			if yyvs7 /= Void then
				yyvs7.clear_all
			end
			if yyvs8 /= Void then
				yyvs8.clear_all
			end
			if yyvs9 /= Void then
				yyvs9.clear_all
			end
			if yyvs10 /= Void then
				yyvs10.clear_all
			end
			if yyvs11 /= Void then
				yyvs11.clear_all
			end
			if yyvs12 /= Void then
				yyvs12.clear_all
			end
			if yyvs13 /= Void then
				yyvs13.clear_all
			end
			if yyvs14 /= Void then
				yyvs14.clear_all
			end
			if yyvs15 /= Void then
				yyvs15.clear_all
			end
			if yyvs16 /= Void then
				yyvs16.clear_all
			end
			if yyvs17 /= Void then
				yyvs17.clear_all
			end
			if yyvs18 /= Void then
				yyvs18.clear_all
			end
			if yyvs19 /= Void then
				yyvs19.clear_all
			end
		end

	yy_push_last_value (yychar1: INTEGER) is
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					if yyvs1 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs1")
						end
						create yyspecial_routines1
						yyvsc1 := yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.make (yyvsc1)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs1")
						end
						yyvsc1 := yyvsc1 + yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
					end
				end
				yyvs1.put (last_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					if yyvs2 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs2")
						end
						create yyspecial_routines2
						yyvsc2 := yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.make (yyvsc2)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs2")
						end
						yyvsc2 := yyvsc2 + yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
					end
				end
				yyvs2.put (last_string_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					if yyvs3 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs3")
						end
						create yyspecial_routines3
						yyvsc3 := yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.make (yyvsc3)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs3")
						end
						yyvsc3 := yyvsc3 + yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
					end
				end
				yyvs3.put (last_integer_value, yyvsp3)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value is
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				if yyvs1 = Void then
					debug ("GEYACC")
						std.error.put_line ("Create yyvs1")
					end
					create yyspecial_routines1
					yyvsc1 := yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.make (yyvsc1)
				else
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
				end
			end
			yyvs1.put (yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER) is
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			when 8 then
				yyvsp8 := yyvsp8 - 1
			when 9 then
				yyvsp9 := yyvsp9 - 1
			when 10 then
				yyvsp10 := yyvsp10 - 1
			when 11 then
				yyvsp11 := yyvsp11 - 1
			when 12 then
				yyvsp12 := yyvsp12 - 1
			when 13 then
				yyvsp13 := yyvsp13 - 1
			when 14 then
				yyvsp14 := yyvsp14 - 1
			when 15 then
				yyvsp15 := yyvsp15 - 1
			when 16 then
				yyvsp16 := yyvsp16 - 1
			when 17 then
				yyvsp17 := yyvsp17 - 1
			when 18 then
				yyvsp18 := yyvsp18 - 1
			when 19 then
				yyvsp19 := yyvsp19 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval1: ANY
			yyval4: EPX_MIME_FIELD
			yyval14: EPX_MIME_FIELD_MAILBOX_LIST
			yyval6: EPX_MIME_FIELD_CONTENT_DISPOSITION
			yyval7: EPX_MIME_FIELD_CONTENT_LENGTH
			yyval8: EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING
			yyval9: EPX_MIME_FIELD_CONTENT_TYPE
			yyval10: EPX_MIME_FIELD_DATE
			yyval11: EPX_MIME_FIELD_IF_MODIFIED_SINCE
			yyval12: EPX_MIME_FIELD_MESSAGE_ID
			yyval13: EPX_MIME_FIELD_MIME_VERSION
			yyval15: EPX_MIME_FIELD_TRANSFER_ENCODING
			yyval16: EPX_MIME_MAILBOX
			yyval17: DS_LINKABLE [EPX_MIME_MAILBOX]
			yyval2: STRING
			yyval18: STDC_TIME
			yyval3: INTEGER
			yyval19: EPX_MIME_PARAMETER
			yyval5: EPX_MIME_UNSTRUCTURED_FIELD
		do
			inspect yy_act
when 1 then
--|#line 169 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 169")
end

accept 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 2 then
--|#line 170 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 170")
end

accept 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 3 then
--|#line 175 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 175")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 4 then
--|#line 176 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 176")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 5 then
--|#line 181 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 181")
end

if yyvs4.item (yyvsp4) /= Void then part.header.add_non_unique_field (yyvs4.item (yyvsp4)) end 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs4.put (yyval4, yyvsp4)
end
when 6 then
--|#line 183 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 183")
end

part.header.add_non_unique_field (yyvs5.item (yyvsp5)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 7 then
--|#line 185 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 185")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs4.put (yyval4, yyvsp4)
end
when 8 then
--|#line 185 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 185")
end

reset_start_condition 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp4 := yyvsp4 + 1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 9 then
--|#line 191 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 191")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 10 then
--|#line 193 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 193")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 11 then
--|#line 195 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 195")
end

yyval4 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 12 then
--|#line 197 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 197")
end

yyval4 := yyvs7.item (yyvsp7) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 13 then
--|#line 199 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 199")
end

yyval4 := yyvs8.item (yyvsp8) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp8 := yyvsp8 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 14 then
--|#line 201 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 201")
end

yyval4 := yyvs9.item (yyvsp9) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 15 then
--|#line 203 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 203")
end

yyval4 := yyvs10.item (yyvsp10) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 16 then
--|#line 205 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 205")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 17 then
--|#line 207 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 207")
end

yyval4 := yyvs11.item (yyvsp11) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp11 := yyvsp11 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 18 then
--|#line 209 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 209")
end

yyval4 := yyvs12.item (yyvsp12) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 19 then
--|#line 211 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 211")
end

yyval4 := yyvs13.item (yyvsp13) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 20 then
--|#line 213 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 213")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 21 then
--|#line 214 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 214")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 22 then
--|#line 216 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 216")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 23 then
--|#line 217 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 217")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 24 then
--|#line 219 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 219")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 25 then
--|#line 220 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 220")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 26 then
--|#line 221 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 221")
end

yyval4 := yyvs14.item (yyvsp14) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp14 := yyvsp14 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 27 then
--|#line 223 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 223")
end

yyval4 := yyvs15.item (yyvsp15) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp4 := yyvsp4 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 28 then
--|#line 231 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 231")
end

			create yyval14.make (field_name_bcc, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 29 then
--|#line 235 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 235")
end

			create yyval14.make (field_name_bcc, Void)
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 30 then
--|#line 242 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 242")
end

			create yyval14.make (field_name_cc, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 31 then
--|#line 246 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 246")
end

			create yyval14.make (field_name_cc, Void)
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 32 then
--|#line 253 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 253")
end

			yyval6 := my_content_disposition
			current_parameter_field := Void
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvs6.put (yyval6, yyvsp6)
end
when 33 then
--|#line 253 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 253")
end

			create my_content_disposition.make (yyvs2.item (yyvsp2))
			current_parameter_field := my_content_disposition
			start_parameter
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp6 := yyvsp6 + 1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 34 then
--|#line 268 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 268")
end

			create yyval7.make (yyvs3.item (yyvsp3))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp7 := yyvsp7 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 35 then
--|#line 276 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 276")
end

			create yyval8.make (yyvs2.item (yyvsp2))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp8 := yyvsp8 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp8 >= yyvsc8 then
		if yyvs8 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs8")
			end
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs8")
			end
			yyvsc8 := yyvsc8 + yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.resize (yyvs8, yyvsc8)
		end
	end
	yyvs8.put (yyval8, yyvsp8)
end
when 36 then
--|#line 284 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 284")
end

			yyval9 := my_content_type
			current_parameter_field := Void
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 37 then
--|#line 284 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 284")
end

			create my_content_type.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
			current_parameter_field := my_content_type
			start_parameter
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp9 := yyvsp9 + 1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 38 then
--|#line 300 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 300")
end

			if yyvs18.item (yyvsp18) /= Void then
				create yyval10.make (yyvs18.item (yyvsp18))
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp18 := yyvsp18 -1
	yyvs10.put (yyval10, yyvsp10)
end
when 39 then
--|#line 300 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 300")
end

expect_date 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp10 := yyvsp10 + 1
	if yyvsp10 >= yyvsc10 then
		if yyvs10 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs10")
			end
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs10")
			end
			yyvsc10 := yyvsc10 + yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.resize (yyvs10, yyvsc10)
		end
	end
	yyvs10.put (yyval10, yyvsp10)
end
when 40 then
--|#line 312 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 312")
end

			create yyval14.make (field_name_from, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 41 then
--|#line 319 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 319")
end

			yyval11 := my_if_modified_since
			current_parameter_field := Void
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp11 := yyvsp11 -1
	yyvsp1 := yyvsp1 -3
	yyvsp18 := yyvsp18 -1
	yyvs11.put (yyval11, yyvsp11)
end
when 42 then
--|#line 319 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 319")
end

expect_date 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp11 := yyvsp11 + 1
	if yyvsp11 >= yyvsc11 then
		if yyvs11 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs11")
			end
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs11")
			end
			yyvsc11 := yyvsc11 + yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.resize (yyvs11, yyvsc11)
		end
	end
	yyvs11.put (yyval11, yyvsp11)
end
when 43 then
--|#line 319 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 319")
end

			create my_if_modified_since.make (yyvs18.item (yyvsp18))
			current_parameter_field := my_if_modified_since
			start_parameter
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp11 := yyvsp11 + 1
	if yyvsp11 >= yyvsc11 then
		if yyvs11 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs11")
			end
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs11")
			end
			yyvsc11 := yyvsc11 + yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.resize (yyvs11, yyvsc11)
		end
	end
	yyvs11.put (yyval11, yyvsp11)
end
when 44 then
--|#line 335 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 335")
end

create yyval12.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp12 := yyvsp12 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 45 then
--|#line 340 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 340")
end

create yyval13.make (yyvs3.item (yyvsp3 - 1), yyvs3.item (yyvsp3)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp13 := yyvsp13 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp3 := yyvsp3 -2
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 46 then
--|#line 346 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 346")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 11
	yyvsp1 := yyvsp1 -9
	yyvsp18 := yyvsp18 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 47 then
--|#line 346 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 346")
end

expect_date 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 48 then
--|#line 357 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 357")
end

			create yyval14.make (field_name_resent_from, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 49 then
--|#line 364 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 364")
end

			create yyval14.make (field_name_resent_reply_to, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 50 then
--|#line 371 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 371")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp16 := yyvsp16 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 51 then
--|#line 375 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 375")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 52 then
--|#line 379 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 379")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp16 := yyvsp16 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 53 then
--|#line 384 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 384")
end

			create yyval14.make (field_name_to, yyvs17.item (yyvsp17))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp17 := yyvsp17 -1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 54 then
--|#line 388 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 388")
end

			create yyval14.make (field_name_to, Void)
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp14 := yyvsp14 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 55 then
--|#line 395 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 395")
end

			yyval15 := my_transfer_encoding
			current_parameter_field := Void
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvs15.put (yyval15, yyvsp15)
end
when 56 then
--|#line 395 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 395")
end

			create my_transfer_encoding.make (yyvs2.item (yyvsp2))
			current_parameter_field := my_transfer_encoding
			start_parameter
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp15 := yyvsp15 + 1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 57 then
--|#line 413 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 413")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs16.put (yyval16, yyvsp16)
end
when 58 then
--|#line 415 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 415")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 59 then
--|#line 420 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 420")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 60 then
--|#line 421 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 421")
end

create yyval17.make (yyvs16.item (yyvsp16)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 61 then
--|#line 423 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 423")
end

create yyval17.make (yyvs16.item (yyvsp16)); yyval17.put_right (yyvs17.item (yyvsp17)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 -1
	yyvsp1 := yyvsp1 -1
	yyvs17.put (yyval17, yyvsp17)
end
when 62 then
--|#line 428 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 428")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 63 then
--|#line 429 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 429")
end

yyval1 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 64 then
--|#line 434 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 434")
end

		create yyval2.make_from_string (yyvs2.item (yyvsp2 - 1))
		yyval2.append_character ('@')
		yyval2.append_string (yyvs2.item (yyvsp2))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 65 then
--|#line 443 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 443")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs2.put (yyval2, yyvsp2)
end
when 66 then
--|#line 445 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 445")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 67 then
--|#line 450 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 450")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 68 then
--|#line 455 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 455")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 69 then
--|#line 461 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 461")
end

yyval18 := yyvs18.item (yyvsp18) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs18.put (yyval18, yyvsp18)
end
when 70 then
--|#line 463 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 463")
end

yyval18 := yyvs18.item (yyvsp18) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs18.put (yyval18, yyvsp18)
end
when 71 then
--|#line 465 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 465")
end

yyval18 := yyvs18.item (yyvsp18) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs18.put (yyval18, yyvsp18)
end
when 72 then
--|#line 470 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 470")
end

			if my_date.is_two_digit_year (yyvs3.item (yyvsp3).item) then
				my_year := my_date.four_digit_year (yyvs3.item (yyvsp3).item)
			else
				my_year := yyvs3.item (yyvsp3).item
			end
			if
				my_date.is_valid_date (my_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3 - 2).item)
			then
				my_date.make_utc_date (my_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3 - 2).item)
				yyval18 := my_date
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp18 := yyvsp18 + 1
	yyvsp3 := yyvsp3 -3
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 73 then
--|#line 487 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 487")
end

			if my_date.is_two_digit_year (yyvs3.item (yyvsp3).item) then
				my_year := my_date.four_digit_year (yyvs3.item (yyvsp3).item)
			else
				my_year := yyvs3.item (yyvsp3).item
			end
			if my_date.is_valid_date (my_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3 - 2).item) then
				my_date.make_utc_date (my_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3 - 2).item)
				yyval18 := my_date
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp18 := yyvsp18 + 1
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -2
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 74 then
--|#line 502 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 502")
end

			if my_date.is_valid_date (my_date.current_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3).item) then
				my_date.make_utc_date (my_date.current_year, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3).item)
				yyval18 := my_date
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp18 := yyvsp18 + 1
	yyvsp3 := yyvsp3 -2
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 75 then
--|#line 514 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 514")
end

			if yyvs18.item (yyvsp18 - 1) /= Void and then yyvs18.item (yyvsp18) /= Void and then my_date.is_valid_date_and_time (yyvs18.item (yyvsp18 - 1).year, yyvs18.item (yyvsp18 - 1).month, yyvs18.item (yyvsp18 - 1).day, yyvs18.item (yyvsp18).hour, yyvs18.item (yyvsp18).minute, yyvs18.item (yyvsp18).second) then
				create yyval18.make_utc_date_time (yyvs18.item (yyvsp18 - 1).year, yyvs18.item (yyvsp18 - 1).month, yyvs18.item (yyvsp18 - 1).day, yyvs18.item (yyvsp18).hour, yyvs18.item (yyvsp18).minute, yyvs18.item (yyvsp18).second)
				minutes := yyvs3.item (yyvsp3).item.abs \\ 100
				hours := yyvs3.item (yyvsp3).item.abs // 100
				seconds := (minutes * 60 + hours * 3600)
				if yyvs3.item (yyvsp3).item < 0 then
					seconds := -1 * seconds
				end
				yyval18.make_from_unix_time (yyval18.value - seconds)
				yyval18.to_utc
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp18 := yyvsp18 -1
	yyvsp1 := yyvsp1 -1
	yyvsp3 := yyvsp3 -1
	yyvs18.put (yyval18, yyvsp18)
end
when 76 then
--|#line 531 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 531")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 77 then
--|#line 532 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 532")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 78 then
--|#line 533 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 533")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 79 then
--|#line 534 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 534")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 80 then
--|#line 535 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 535")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 81 then
--|#line 536 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 536")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 82 then
--|#line 537 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 537")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 83 then
--|#line 541 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 541")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 84 then
--|#line 546 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 546")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 85 then
--|#line 548 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 548")
end

yyval2 := yyvs2.item (yyvsp2 - 1) + "." + yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 86 then
--|#line 553 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 553")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 87 then
--|#line 558 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 558")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 88 then
--|#line 563 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 563")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 89 then
--|#line 565 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 565")
end

yyval2 := yyvs2.item (yyvsp2 - 1) + "." + yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 90 then
--|#line 570 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 570")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp17 := yyvsp17 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 91 then
--|#line 574 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 574")
end

			if my_time.is_valid_time (yyvs3.item (yyvsp3 - 2).item, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3).item) then
				my_time.make_utc_time (yyvs3.item (yyvsp3 - 2).item, yyvs3.item (yyvsp3 - 1).item, yyvs3.item (yyvsp3).item)
				yyval18 := my_time
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp18 := yyvsp18 + 1
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 92 then
--|#line 584 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 584")
end

yyval18 := yyvs18.item (yyvsp18) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs18.put (yyval18, yyvsp18)
end
when 93 then
--|#line 589 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 589")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 94 then
--|#line 591 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 591")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 95 then
--|#line 601 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 601")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 96 then
--|#line 603 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 603")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 97 then
--|#line 605 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 605")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 98 then
--|#line 611 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 611")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 99 then
--|#line 617 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 617")
end

		if yyvs2.item (yyvsp2).is_integer then
			yyval3 := yyvs2.item (yyvsp2).to_integer
		else
			abort
		end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 100 then
--|#line 628 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 628")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 101 then
--|#line 630 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 630")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 102 then
--|#line 636 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 636")
end

create yyval16.make (Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 103 then
--|#line 638 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 638")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs16.put (yyval16, yyvsp16)
end
when 104 then
--|#line 643 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 643")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 105 then
--|#line 644 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 644")
end

create yyval17.make (yyvs16.item (yyvsp16)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 106 then
--|#line 646 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 646")
end

create yyval17.make (yyvs16.item (yyvsp16)); yyval17.put_right (yyvs17.item (yyvsp17)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 -1
	yyvsp1 := yyvsp1 -1
	yyvs17.put (yyval17, yyvsp17)
end
when 107 then
--|#line 651 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 651")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 108 then
--|#line 658 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 658")
end

yyval2 := yyvs2.item (yyvsp2 - 1) + yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs2.put (yyval2, yyvsp2)
end
when 109 then
--|#line 660 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 660")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 110 then
--|#line 665 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 665")
end

create yyval16.make (Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 111 then
--|#line 667 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 667")
end

create yyval16.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp16 := yyvsp16 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 112 then
--|#line 672 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 672")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 113 then
--|#line 677 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 677")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs2.put (yyval2, yyvsp2)
end
when 114 then
--|#line 684 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 684")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 115 then
--|#line 688 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 688")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 116 then
--|#line 689 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 689")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 117 then
--|#line 693 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 693")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 118 then
--|#line 694 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 694")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 119 then
--|#line 698 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 698")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 120 then
--|#line 702 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 702")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 121 then
--|#line 703 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 703")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 122 then
--|#line 707 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 707")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 123 then
--|#line 708 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 708")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 124 then
--|#line 712 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 712")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 125 then
--|#line 713 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 713")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 126 then
--|#line 719 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 719")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 127 then
--|#line 720 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 720")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 128 then
--|#line 721 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 721")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 129 then
--|#line 727 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 727")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 130 then
--|#line 728 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 728")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 131 then
--|#line 732 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 732")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 132 then
--|#line 733 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 733")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 133 then
--|#line 737 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 737")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp17 := yyvsp17 + 1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 134 then
--|#line 738 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 738")
end

yyval17 := yyvs17.item (yyvsp17) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs17.put (yyval17, yyvsp17)
end
when 135 then
--|#line 743 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 743")
end

yyval3 := 0 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 136 then
--|#line 745 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 745")
end

yyval3 := yyvs3.item (yyvsp3).item 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 137 then
--|#line 750 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 750")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 138 then
--|#line 751 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 751")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 139 then
--|#line 755 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 755")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 140 then
--|#line 756 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 756")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 141 then
--|#line 760 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 760")
end

			yyvs2.item (yyvsp2 - 1).to_lower
			create yyval19.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
			current_parameter_field.parameters.put (yyval19, yyvs2.item (yyvsp2 - 1))
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp19 := yyvsp19 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp19 >= yyvsc19 then
		if yyvs19 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs19")
			end
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs19")
			end
			yyvsc19 := yyvsc19 + yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.resize (yyvs19, yyvsc19)
		end
	end
	yyvs19.put (yyval19, yyvsp19)
end
when 142 then
--|#line 769 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 769")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 143 then
--|#line 770 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 770")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 144 then
--|#line 776 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 776")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 145 then
--|#line 777 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 777")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 146 then
--|#line 778 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 778")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp19 := yyvsp19 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 147 then
--|#line 784 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 784")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 148 then
--|#line 785 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 785")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 149 then
--|#line 786 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 786")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 150 then
--|#line 790 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 790")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 151 then
--|#line 795 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 795")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 152 then
--|#line 797 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 797")
end

yyval2 := yyvs2.item (yyvsp2 - 1); yyval2.append_character (' '); yyval2.append_string (yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 153 then
--|#line 802 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 802")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 154 then
--|#line 807 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 807")
end

yyval2  := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 155 then
--|#line 809 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 809")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 156 then
--|#line 814 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 814")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 157 then
--|#line 819 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 819")
end

yyval18 := yyvs18.item (yyvsp18) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs18.put (yyval18, yyvsp18)
end
when 158 then
--|#line 824 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 824")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 159 then
--|#line 831 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 831")
end

			if STRING_.same_string (yyvs2.item (yyvsp2).as_lower, "multipart") then
				yyval2 := "multipart"
				part.create_multipart_body
			else
				yyval2 := yyvs2.item (yyvsp2)
			end
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 160 then
--|#line 843 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 843")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 161 then
--|#line 845 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 845")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 162 then
--|#line 850 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 850")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 163 then
--|#line 851 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 851")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 164 then
--|#line 855 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 855")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 165 then
--|#line 857 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 857")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 166 then
--|#line 866 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 866")
end

yyval3 := yyvs3.item (yyvsp3).item 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 167 then
--|#line 868 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 868")
end

yyval3 := yyvs3.item (yyvsp3).item 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 168 then
--|#line 873 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 873")
end

yyval3 := 0 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 169 then
--|#line 875 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 875")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 170 then
--|#line 882 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 882")
end

create yyval5.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp5 := yyvsp5 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 171 then
--|#line 887 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 887")
end

yyval2 := "" 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 172 then
--|#line 889 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 889")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 266 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,   53,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,   47,   51,   45,   44,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,   43,   46,
			   49,   52,   50,    2,   48,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42, yyDummy>>)
		end

	yyr1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,  118,  118,  119,  119,   54,   54,   54,  120,   56,
			   56,   56,   56,   56,   56,   56,   56,   56,   56,   56,
			   56,   56,   56,   56,   56,   56,   56,   56,   65,   65,
			   66,   66,   57,  126,   58,   59,   60,  127,   61,  128,
			   67,   62,  129,  130,   63,   64,  121,  137,   68,   69,
			  122,  123,  124,   70,   70,   71,  139,   72,   72,   73,
			   73,   73,  141,  141,   74,   75,   75,   77,   78,   79,
			   79,   79,   80,   81,   82,   83,  143,  143,  143,  143,
			  143,  143,  143,   84,   85,   85,   86,   87,   88,   88,
			  140,   89,   90,   91,   91,   92,   92,   92,   93,  116,

			   94,   94,   95,   95,   96,   96,   96,   98,   99,   99,
			  100,  100,  101,   76,  144,  145,  145,  146,  146,  147,
			  132,  132,  142,  142,  148,  148,  136,  136,  136,  131,
			  131,  135,  135,   97,   97,  106,  106,  133,  133,  134,
			  134,  102,  125,  125,  150,  150,  150,  138,  138,  138,
			  103,  105,  105,  104,  107,  107,  108,  109,  110,  111,
			  112,  112,  149,  149,  117,  117,  113,  113,  114,  114,
			   55,  115,  115, yyDummy>>)
		end

	yytypes1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    4,    5,    4,    6,    7,    8,    9,
			   10,   11,   12,   13,   14,   14,   14,   14,   14,   14,
			   15,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    4,    1,    1,    1,
			    1,    2,    2,    2,    2,    3,    2,    2,    1,    1,
			    2,   16,   17,    2,    2,    2,    2,    2,    2,    2,
			    2,   16,   16,    2,    2,    2,    2,    1,   16,    2,

			   16,   17,    1,   16,   17,    1,    2,    2,    2,    2,
			    1,    1,    1,    1,    1,    2,    2,   11,   17,   10,
			    2,    2,    2,    2,    3,    2,   17,   17,    1,    1,
			   15,    1,    1,    2,    1,    1,    1,    1,    1,    2,
			    1,    1,    2,    2,    2,    1,    2,    1,    2,    2,
			    2,    2,    2,    1,    1,    2,    2,    2,    2,    1,
			    1,    1,    1,    1,    1,    1,   18,   18,    1,    1,
			   18,    1,    6,    3,    1,    1,    1,    2,    1,    2,
			    1,    1,   17,    2,    2,   17,   17,   17,    1,    2,
			    1,    1,    2,    1,    1,    1,   11,    3,    3,   18,

			   18,   18,   18,    1,    2,    2,    1,    2,   19,    2,
			    1,    1,    2,    2,    1,    1,    1,    2,    2,    2,
			    2,    2,    1,    1,    3,    3,    3,   18,   18,    9,
			    1,    1,    2,    1,    1,    1,    3,    3,    1,    1,
			    3,    3,    3,    1,    2,    2,    2,    1,    2,    1,
			    1,    1,    3,    3,    1,    2,    1,    3,    1,    3,
			    1,    2,    1,    3,    1,   18,    1,    1,    1, yyDummy>>)
		end

	yytypes2_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    2,    2,    3,    3,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    8,    0,    0,    0,   11,   12,   13,   14,
			   15,   17,   18,   19,    9,   10,   16,   21,   23,   26,
			   27,    0,   20,   22,   24,   25,  171,    0,    0,   54,
			    0,    0,    0,    0,    0,  129,    0,   42,    0,   39,
			    0,    0,    0,    0,   31,   29,    0,    4,    6,    5,
			    1,  172,  170,   67,   99,    0,  158,   56,    0,   59,
			  165,   60,   53,  102,  110,   66,  164,    0,  100,   87,
			    0,   57,  103,   83,  151,  150,  153,   58,   52,   83,

			   50,   49,  104,  105,   48,   62,  101,  149,  119,   88,
			   51,  148,    0,  120,    0,  109,   44,  122,   40,  122,
			  159,    0,  107,   35,   34,   33,   30,   28,    7,    0,
			  142,    0,  117,    0,    0,    0,  115,    0,    0,  111,
			    0,  133,  165,  164,  152,    0,   63,    0,  155,   86,
			  124,  154,   84,    0,  137,  112,   93,    0,   94,   82,
			   81,   80,   79,   78,   77,   76,   92,   43,    0,    0,
			   38,    0,  142,   45,  145,   55,  143,  118,   65,    0,
			  114,  116,   61,   89,   64,  134,    0,  106,  147,  125,
			  130,    0,  121,    0,  139,    0,  142,    0,    0,    0,

			   69,   70,   71,  123,  156,   37,   32,    0,  144,   68,
			  113,   90,   85,  138,    0,  131,  140,   98,   95,    0,
			   97,   96,   41,    0,    0,   74,    0,  157,  168,  142,
			    0,  146,  162,    0,  126,  108,    0,   72,    0,    0,
			  166,  169,   75,   36,  161,  160,  141,  163,  132,    0,
			    0,    0,  135,    0,    0,  127,   47,   73,    0,   91,
			  167,    0,  122,  136,  128,   46,    0,    0,    0, yyDummy>>)
		end

	yydefgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
			   33,   34,   35,   36,   37,   38,   39,   40,   81,   82,
			   83,   84,   85,   86,  207,  199,  200,  201,  202,  166,
			   87,  150,  151,   88,   89,  227,  167,  157,  219,  220,
			   90,   91,  104,  186,  123,  116,   92,  158,  208,   99,
			   94,   95,  259,  152,  205,  228,   77,  121,  246,  241,
			  242,   72,   75,   96,  266,   41,   66,   42,   43,   44,
			   45,  175,  172,  229,  119,  117,  196,  113,  154,  194,
			  215,  234,  250,  262,  110,  130,   97,  147,  168,  169,
			  134,  135,  136,  111,  190,  216,  176, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			  245, -32768,  151,  150,  149,  148,  147,  146,  145,  144,
			  142,  141,  139,  138,  137,  136,  135,  134,  133,  132,
			  131,  130, -32768,  205,  129,  128, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  126, -32768, -32768, -32768, -32768,  116,   88,   88,   14,
			   40,   40,   14,    8,   27,  124,   20, -32768,    8, -32768,
			   88,   88,   88,   88,   14,   14,  122, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  117, -32768, -32768,   24, -32768,
			  115,  114, -32768, -32768, -32768, -32768,   29,  103, -32768, -32768,
			  112, -32768, -32768,  113,   99, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768,  111, -32768,   24, -32768, -32768, -32768,  110,
			 -32768, -32768,   75,  123,   87, -32768, -32768,   81, -32768,   81,
			 -32768,  105, -32768, -32768, -32768, -32768, -32768, -32768, -32768,   88,
			   82,   75, -32768,  101,   46,   32, -32768,   14,   88, -32768,
			   75,    8, -32768, -32768, -32768,    8, -32768,   95, -32768, -32768,
			  120, -32768,   96,   75,  107, -32768, -32768,   94, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  100,   93,
			 -32768,   88,   82, -32768,   88, -32768, -32768, -32768, -32768,   89,
			 -32768, -32768, -32768, -32768, -32768, -32768,   91, -32768, -32768, -32768,
			 -32768,   75, -32768,   88,   90,   79,   82,   34,  109,  108,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,   84,   82, -32768,
			 -32768, -32768, -32768, -32768,   88,  102, -32768, -32768, -32768,   83,
			 -32768, -32768, -32768,  106,  104, -32768,   86, -32768,    0,   82,
			   68, -32768,   90,   88,   77, -32768,    9, -32768,   78,   60,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,   17,
			   48,   55,   13,  -13,   46, -32768, -32768, -32768,   26, -32768,
			 -32768,  -21,   81, -32768, -32768, -32768,   33,   10, -32768, yyDummy>>)
		end

	yypgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  -30,
			  -51,  118,  173,  -47, -32768, -32768, -32768, -32768, -32768, -115,
			 -32768, -103, -32768, -32768,  -95, -32768, -32768, -32768, -32768, -32768,
			 -32768,  -33,  -46, -32768, -32768, -32768, -32768,  -23, -32768,  -41,
			 -32768,  140, -32768, -32768, -32768, -32768,  -61, -32768, -32768, -32768,
			 -32768, -32768,  -56, -32768, -32768,  143, -32768, -32768, -32768, -32768,
			 -32768, -151, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,   30, -32768, -32768,  -73,  -54, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			   74,   76,  125,  107,  170,  115,  124,  109,   93,  109,
			  268,   93,  118,  120,  122,   74,   76,   98,  100,  156,
			  103,  206,  101,   93,   93,  103,  240,  133,  177,  264,
			   73,  109,   80,  267,  126,  127,   73,  184,   80,   73,
			  260,  106,   73,  183,  106,  222,   73,  143,  106,   73,
			  192,  106,  263,  239,  146,  102,  258,   78,  109,  224,
			  251,   79,   73,   78,   80,  149,  254,  109,   73,  114,
			  106,  132,  131,  173,  138,  180,  105,  -88,  243,  132,
			  131,  257,   74,  179,  149,  223,  253,  109,  212,   78,
			   73,  109,  244,  149,  256,  185,   93,   73,  148,  187,

			  218,   73,  217,  155,  252,  249,  149,  182,  103,   73,
			   73,  155,  103,  209,  165,  164,  163,  162,  161,  160,
			  159,   73,  214,  142,  204,  198,  197,   76,  174,  238,
			  237,  236,  233,  235,  226,  225,  230,  211,  193,  210,
			  203,  191,  195,  189,  149,  188,  213,  265,  109,  171,
			  153,  178,   78,  112,  231,  138,  141,   71,  145,  247,
			  140,  137,  129, -101,  128,  181,   67,  232,   70,  245,
			   69,   68,  221,   65,   64,   63,   62,   61,   60,   59,
			   58,   57,   56,   76,   55,   54,  248,   53,   52,   51,
			   50,   49,   48,   47,   46,    0,    0,    0,  255,    0,

			    0,    0,  109,  261,    0,  139,   22,  109,   21,   20,
			   19,   18,   17,   16,   15,   14,   13,   12,   11,   10,
			    9,    8,    7,    6,    5,    4,    3,  108,    0,    0,
			    0,    0,    0,    0,  144,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    2,   22,   -3,   21,   20,
			   19,   18,   17,   16,   15,   14,   13,   12,   11,   10,
			    9,    8,    7,    6,    5,    4,    3,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    2,    0,    1, yyDummy>>)
		end

	yycheck_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			   47,   48,   63,   54,  119,   56,   62,   54,   49,   56,
			    0,   52,   58,   60,   61,   62,   63,   50,   51,  114,
			   53,  172,   52,   64,   65,   58,   26,   78,  131,   50,
			   22,   78,   24,    0,   64,   65,   22,  140,   24,   22,
			   53,   24,   22,  138,   24,  196,   22,   94,   24,   22,
			  153,   24,   26,   53,  105,   47,   43,   49,  105,   25,
			   51,   47,   22,   49,   24,  112,   49,  114,   22,   49,
			   24,   47,   48,  129,   45,   43,   49,   48,  229,   47,
			   48,   26,  129,  134,  131,   51,   26,  134,  191,   49,
			   22,  138,   24,  140,   46,  141,  137,   22,   23,  145,

			  195,   22,   23,   24,   26,   28,  153,  137,  141,   22,
			   22,   24,  145,  174,   33,   34,   35,   36,   37,   38,
			   39,   22,   32,   24,  171,   25,   26,  174,   46,   43,
			   26,   25,   30,   50,   26,   26,   52,   46,   31,   50,
			   47,   45,   48,   23,  191,   50,  193,  262,  195,   44,
			   27,   50,   49,   29,  208,   45,   43,   41,   47,  232,
			   48,   47,   45,   48,   42,  135,   23,  214,   42,  230,
			   42,   42,  195,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,  230,   43,   43,  233,   43,   43,   43,
			   43,   43,   43,   43,   43,   -1,   -1,   -1,  249,   -1,

			   -1,   -1,  249,  254,   -1,   87,    1,  254,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   54,   -1,   -1,
			   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   40,    1,   42,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   40,   -1,   42, yyDummy>>)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [ANY]
			-- Stack for semantic values of type ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [ANY]
			-- Routines that ought to be in SPECIAL [ANY]

	yyvs2: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs3: SPECIAL [INTEGER]
			-- Stack for semantic values of type INTEGER

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [INTEGER]
			-- Routines that ought to be in SPECIAL [INTEGER]

	yyvs4: SPECIAL [EPX_MIME_FIELD]
			-- Stack for semantic values of type EPX_MIME_FIELD

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD]

	yyvs5: SPECIAL [EPX_MIME_UNSTRUCTURED_FIELD]
			-- Stack for semantic values of type EPX_MIME_UNSTRUCTURED_FIELD

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [EPX_MIME_UNSTRUCTURED_FIELD]
			-- Routines that ought to be in SPECIAL [EPX_MIME_UNSTRUCTURED_FIELD]

	yyvs6: SPECIAL [EPX_MIME_FIELD_CONTENT_DISPOSITION]
			-- Stack for semantic values of type EPX_MIME_FIELD_CONTENT_DISPOSITION

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_CONTENT_DISPOSITION]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_CONTENT_DISPOSITION]

	yyvs7: SPECIAL [EPX_MIME_FIELD_CONTENT_LENGTH]
			-- Stack for semantic values of type EPX_MIME_FIELD_CONTENT_LENGTH

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_CONTENT_LENGTH]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_CONTENT_LENGTH]

	yyvs8: SPECIAL [EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING]
			-- Stack for semantic values of type EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING

	yyvsc8: INTEGER
			-- Capacity of semantic value stack `yyvs8'

	yyvsp8: INTEGER
			-- Top of semantic value stack `yyvs8'

	yyspecial_routines8: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING]

	yyvs9: SPECIAL [EPX_MIME_FIELD_CONTENT_TYPE]
			-- Stack for semantic values of type EPX_MIME_FIELD_CONTENT_TYPE

	yyvsc9: INTEGER
			-- Capacity of semantic value stack `yyvs9'

	yyvsp9: INTEGER
			-- Top of semantic value stack `yyvs9'

	yyspecial_routines9: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_CONTENT_TYPE]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_CONTENT_TYPE]

	yyvs10: SPECIAL [EPX_MIME_FIELD_DATE]
			-- Stack for semantic values of type EPX_MIME_FIELD_DATE

	yyvsc10: INTEGER
			-- Capacity of semantic value stack `yyvs10'

	yyvsp10: INTEGER
			-- Top of semantic value stack `yyvs10'

	yyspecial_routines10: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_DATE]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_DATE]

	yyvs11: SPECIAL [EPX_MIME_FIELD_IF_MODIFIED_SINCE]
			-- Stack for semantic values of type EPX_MIME_FIELD_IF_MODIFIED_SINCE

	yyvsc11: INTEGER
			-- Capacity of semantic value stack `yyvs11'

	yyvsp11: INTEGER
			-- Top of semantic value stack `yyvs11'

	yyspecial_routines11: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_IF_MODIFIED_SINCE]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_IF_MODIFIED_SINCE]

	yyvs12: SPECIAL [EPX_MIME_FIELD_MESSAGE_ID]
			-- Stack for semantic values of type EPX_MIME_FIELD_MESSAGE_ID

	yyvsc12: INTEGER
			-- Capacity of semantic value stack `yyvs12'

	yyvsp12: INTEGER
			-- Top of semantic value stack `yyvs12'

	yyspecial_routines12: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_MESSAGE_ID]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_MESSAGE_ID]

	yyvs13: SPECIAL [EPX_MIME_FIELD_MIME_VERSION]
			-- Stack for semantic values of type EPX_MIME_FIELD_MIME_VERSION

	yyvsc13: INTEGER
			-- Capacity of semantic value stack `yyvs13'

	yyvsp13: INTEGER
			-- Top of semantic value stack `yyvs13'

	yyspecial_routines13: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_MIME_VERSION]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_MIME_VERSION]

	yyvs14: SPECIAL [EPX_MIME_FIELD_MAILBOX_LIST]
			-- Stack for semantic values of type EPX_MIME_FIELD_MAILBOX_LIST

	yyvsc14: INTEGER
			-- Capacity of semantic value stack `yyvs14'

	yyvsp14: INTEGER
			-- Top of semantic value stack `yyvs14'

	yyspecial_routines14: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_MAILBOX_LIST]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_MAILBOX_LIST]

	yyvs15: SPECIAL [EPX_MIME_FIELD_TRANSFER_ENCODING]
			-- Stack for semantic values of type EPX_MIME_FIELD_TRANSFER_ENCODING

	yyvsc15: INTEGER
			-- Capacity of semantic value stack `yyvs15'

	yyvsp15: INTEGER
			-- Top of semantic value stack `yyvs15'

	yyspecial_routines15: KL_SPECIAL_ROUTINES [EPX_MIME_FIELD_TRANSFER_ENCODING]
			-- Routines that ought to be in SPECIAL [EPX_MIME_FIELD_TRANSFER_ENCODING]

	yyvs16: SPECIAL [EPX_MIME_MAILBOX]
			-- Stack for semantic values of type EPX_MIME_MAILBOX

	yyvsc16: INTEGER
			-- Capacity of semantic value stack `yyvs16'

	yyvsp16: INTEGER
			-- Top of semantic value stack `yyvs16'

	yyspecial_routines16: KL_SPECIAL_ROUTINES [EPX_MIME_MAILBOX]
			-- Routines that ought to be in SPECIAL [EPX_MIME_MAILBOX]

	yyvs17: SPECIAL [DS_LINKABLE [EPX_MIME_MAILBOX]]
			-- Stack for semantic values of type DS_LINKABLE [EPX_MIME_MAILBOX]

	yyvsc17: INTEGER
			-- Capacity of semantic value stack `yyvs17'

	yyvsp17: INTEGER
			-- Top of semantic value stack `yyvs17'

	yyspecial_routines17: KL_SPECIAL_ROUTINES [DS_LINKABLE [EPX_MIME_MAILBOX]]
			-- Routines that ought to be in SPECIAL [DS_LINKABLE [EPX_MIME_MAILBOX]]

	yyvs18: SPECIAL [STDC_TIME]
			-- Stack for semantic values of type STDC_TIME

	yyvsc18: INTEGER
			-- Capacity of semantic value stack `yyvs18'

	yyvsp18: INTEGER
			-- Top of semantic value stack `yyvs18'

	yyspecial_routines18: KL_SPECIAL_ROUTINES [STDC_TIME]
			-- Routines that ought to be in SPECIAL [STDC_TIME]

	yyvs19: SPECIAL [EPX_MIME_PARAMETER]
			-- Stack for semantic values of type EPX_MIME_PARAMETER

	yyvsc19: INTEGER
			-- Capacity of semantic value stack `yyvs19'

	yyvsp19: INTEGER
			-- Top of semantic value stack `yyvs19'

	yyspecial_routines19: KL_SPECIAL_ROUTINES [EPX_MIME_PARAMETER]
			-- Routines that ought to be in SPECIAL [EPX_MIME_PARAMETER]

feature {NONE} -- Constants

	yyFinal: INTEGER is 268
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 54
			-- Number of tokens

	yyLast: INTEGER is 287
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 297
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 151
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features




feature -- Initialization

	make is
		do
			if last_line = Void then
				make_scanner
				precursor
				create last_line.make (128)
			end
			level := 1
			boundary := Void
			create my_date.make_from_now
			my_date.to_utc
			create my_time.make_from_now
			my_time.to_utc
		end

	make_from_file (a_file: STDC_TEXT_FILE) is
			-- Like `make_from_stream', but turns off buffering in
			-- `a_file'.
		require
			file_not_void: a_file /= Void
			file_open: a_file.is_open
		do
			-- BdB: why did I turn off buffering??
			a_file.set_no_buffering
			make_from_stream (a_file)
		end

	make_from_stream (a_stream: EPX_CHARACTER_INPUT_STREAM) is
		require
			stream_not_void: a_stream /= Void
			stream_open: a_stream.is_open_read
		do
			make
			set_input_buffer (new_mime_request_buffer (a_stream))
		end

	make_from_file_descriptor (a_fd: ABSTRACT_FILE_DESCRIPTOR) is
		obsolete "Use make_from_stream instead."
		do
			make_from_stream (a_fd)
		end


feature -- Character reading

	eof: BOOLEAN is
			-- True if `read_character' hits end-of-file.
		obsolete "2006-04-03 use end_of_input instead"
		do
			Result := end_of_input
		end

	end_of_input: BOOLEAN is
			-- Has `read_character' hit the end-of-file character?
		do
			Result :=
				last_character = yyEnd_of_file_character and
				not input_buffer.filled
		end


feature {NONE} -- Scanning

	regular_buffer: like input_buffer
			-- Cache of `input_buffer', to be copied back on `wrap'.

	wrap: BOOLEAN is
			-- Check if we were parsing header, if so, resume with main
			-- buffer.
		do
			if regular_buffer /= Void then
				set_input_buffer (regular_buffer)
				regular_buffer := Void
			else
				Result := precursor
			end
		ensure then
			regular_buffer_void: regular_buffer = Void
		end


feature -- Parsing

	reset_parsing_errors is
			-- Reset count of parsing errors.
		do
			parsing_errors := 0
			accept
		ensure
			no_parsing_errors: parsing_errors = 0
		end

	parse is
			-- Read input and build `part'.
			-- Check `syntax_error' for parsing errors.
		do
			create part.make_empty
			parsing_errors := 0
			inner_parse
		end

	parse_body is
			-- Parse MIME body.
			-- Assume `input_buffer' points to body part.
			-- If `a_content_length' positive, scans only as much body as
			-- given by `a_content_length', given that the input buffer
			-- is an EPX_MIME_BUFFER.
		require
			header_parsed: part /= Void
			part_not_void: part /= Void
		local
			buf: EPX_MIME_BUFFER
			is_multipart_body: BOOLEAN
			multipart_body: EPX_MIME_BODY_MULTIPART
			save_part: EPX_MIME_PART
			save_boundary: STRING
			parse_headers_after_chunk: BOOLEAN
		do
			-- Maximum size to parse is either determined by the
			-- Transfer-Coding or Content-Length. Both are specific to
			-- RFC 2616 MIME messages.
			if part.header.transfer_encoding /= Void then
				-- We only support chunked encoding.
				if part.header.transfer_encoding.is_chunked_coding then
					buf ?= input_buffer
					if buf /= Void then
						buf.set_index (yy_end)
						buf.set_transfer_encoding_chunked
						yy_end := buf.count + 1
						parse_headers_after_chunk := True
					end
				end
			elseif
				part.header.content_length /= Void and then
				part.header.content_length.length > 0
			then
				buf ?= input_buffer
				if buf /= Void then
					buf.set_index (yy_end)
					buf.set_end_of_file_on_content_length (part.header.content_length.length)
				end
			end

			-- Be very careful in determining if we should parse a
			-- multipart body.
			is_multipart_body :=
				part.body /= Void and then part.body.is_multipart and then
				part.header.content_type /= Void and then part.header.content_type.parameters.has (parameter_name_boundary)
			if is_multipart_body then
				part.header.content_type.parameters.search (parameter_name_boundary)
				is_multipart_body := part.header.content_type.parameters.found
				if is_multipart_body then
					save_boundary := boundary
					boundary := "--" + part.header.content_type.parameters.found_item.value
					is_multipart_body := boundary.count <= Max_rfc_2046_boundary_length + 2
				end
			end

			if is_multipart_body then
				-- Some overflow test here in `level'?
				level := level + 1
				save_part := part
				multipart_body ?= save_part.body
				forward_to_boundary
				-- Because we call ourselves recursively, we have to be
				-- very careful that state is correctly saved.
				from
				until
					end_of_file or else
					end_of_input or else
					boundary_with_trailer_read
				loop
					part := multipart_body.new_part
					inner_parse
				end
				boundary_with_trailer_read := False
				level := level - 1
				part := save_part
				if save_boundary /= Void and then boundary /= save_boundary then
					-- boundary changed (multipart in multipart), move
					-- forward to boundary, that's the end of the multipart
					-- in side the multipart.
					boundary := save_boundary
					forward_to_boundary
				end
			else
				-- We get here to read a body which ends with end_of_input or
				-- a mime boundary. Make sure we have a single part body.
				part.clear_body
				part.create_singlepart_body
				read_singlepart_body (part.header.content_transfer_encoding)
			end

			if
				not syntax_error and then
				parse_headers_after_chunk and then
				not buf.chunk_encoding_error
			then
				-- trailer can follow, parse it as well and append the fields
				buf.read_headers_after_chunk
				read_character
				if not end_of_input then
					less (0)
					set_start_condition (INITIAL)
					do_parse
				end
			end

			if
				parse_headers_after_chunk and then
				buf.chunk_encoding_error
			then
				error_count := error_count + 1
				abort
			end
		end

	parse_header is
			-- Read just the MIME header from the input and build a new
			-- `part'.  Check `syntax_error' for parsing errors.
		local
			buf: EPX_MIME_BUFFER
		do
			buf ?= input_buffer
			if buf /= Void then
				buf.set_end_of_file_on_end_of_header (True)
			end
			create part.make_empty
			reset_parsing_errors
			set_start_condition (INITIAL)
			do_parse
		end

	set_header (a_header: STRING) is
			-- Optional header that is parsed before the regular input
			-- is parsed.
		require
			a_header_not_empty: a_header /= Void and then not a_header.is_empty
		local
			string_buffer: YY_BUFFER
		do
			regular_buffer := input_buffer
			create string_buffer.make (a_header)
			set_input_buffer (string_buffer)
		end

	parsing_errors: INTEGER
			-- Number of errors encountered when parsing.


feature {NONE} -- Parse

	inner_parse is
			-- Read input and build `part'.
			-- To be called from inside `parse_body'.
		require
			part_not_void: part /= Void
		do
			set_start_condition (INITIAL)
			do_parse
			parse_body
		end


feature {NONE} -- Error reporting

	report_error (a_message: STRING) is
			-- Dump error to stderr. Needs to be rewritten.
		do
			debug ("mime")
				std.error.put_string ("line ")
				std.error.put_integer (line)
				std.error.put_string (", ")
				std.error.put_integer (column)
				std.error.put_string (": ")
				std.error.put_string (a_message)
				std.error.put_character ('%N')
				std.error.put_string ("  text: %"")
				if last_string_value /= Void then
					std.error.put_string (last_string_value.out)
				end
				std.error.put_string ("%" (")
				std.error.put_string (text)
				std.error.put_string (")%N")
				std.error.put_string ("  token: ")
				std.error.put_integer (last_token)
				std.error.put_character ('%N')

				--exit_with_failure
				exceptions.raise ("problem")
			end
			parsing_errors := parsing_errors + 1
		end


feature -- State

	part: EPX_MIME_PART
			-- Structure we're building


feature {NONE} -- State used during parsing

	seconds,
	minutes,
	hours: INTEGER

	level: INTEGER

	my_content_disposition: EPX_MIME_FIELD_CONTENT_DISPOSITION

	my_content_type: EPX_MIME_FIELD_CONTENT_TYPE

	my_transfer_encoding: EPX_MIME_FIELD_TRANSFER_ENCODING

	my_if_modified_since: EPX_MIME_FIELD_IF_MODIFIED_SINCE

	my_date: STDC_TIME

	my_time: STDC_TIME

	my_year: INTEGER

	current_parameter_field: EPX_MIME_FIELD_WITH_PARAMETERS


feature {NONE} -- Reading mime bodies

	boundary: STRING
			-- For multipart MIME messages, it designates the end of a body.

	boundary_with_trailer_read: BOOLEAN

	determine_boundary_with_trailer_read is
			-- There was a boundary match, determine if two dashes follow
			-- (last boundary) and set `boundary_with_trailer_read' in that case.
		do
			-- NOTE: we've already read one character.
			boundary_with_trailer_read := last_character = '-'
			if boundary_with_trailer_read then
				read_character
				boundary_with_trailer_read := last_character = '-'
			end
		end

	forward_to_boundary is
			-- Move input cursor to line that contains `boundary'.
			-- Assume we start reading at beginning of a line.
		require
			boundary_not_empty: boundary /= Void and then not boundary.is_empty
		local
			boundary_read: BOOLEAN
			matching_boundary: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
		do
			from
				matching_boundary := True
				matched_index := 1
				read_character
			until
				end_of_input or else
				boundary_read
			loop
				if last_character = '%N' then
					-- Start matching beginning of boundary
					matching_boundary := True
					matched_index := 1
				else
					if matching_boundary then
						match := boundary.item (matched_index) = last_character
						if match then
							-- Match found, advance to next character.
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							matching_boundary := False
						end
					end
				end
				read_character
			end

			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line
		end

	forward_to_end_of_line is
			-- Always move cursor to next line.
		do
			from
			until
				end_of_input or else
				last_character = '%N'
			loop
				read_character
			end
		ensure
			cursor_at_new_line: end_of_input or else last_character = '%N'
		end

	is_text_body: BOOLEAN is
			-- Contains part.body text?
		local
			text_body: EPX_MIME_BODY_TEXT
		do
			text_body ?= part.body
			Result := text_body /= Void
		end

	last_line: STRING
			-- We store last read line here when reading multipart bodies

	Max_rfc_2046_boundary_length: INTEGER is 70
			-- Max length of a boundary according to RFC 2046

	read_singlepart_body (encoding: EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING) is
			-- Read from input until end of file is reached or a line
			-- contains `boundary'.
		require
			body_not_void: part.body /= Void
			body_is_single_part: not part.body.is_multipart
		local
			body: EPX_MIME_BODY_TEXT
		do
			if boundary = Void then
				read_singlepart_body_without_boundary
			else
				read_singlepart_body_with_boundary
			end
			if encoding /= Void then
				body ?= part.body
				if body /= Void then
					body.set_decoder (encoding.new_decoder)
				end
			end
		end

	read_singlepart_body_with_boundary is
			-- Start reading a single part. This routine has to do two
			-- things right: it has to stop when a boundary has been
			-- parsed, and the cr+lf before the boundary is not part of
			-- the file.
		require
			boundary_is_set: boundary /= Void
			has_buffer: last_line /= Void
			body_contains_text: is_text_body
		local
			boundary_read: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
			c: CHARACTER
			matching_boundary: BOOLEAN
			body: EPX_MIME_BODY_TEXT
			add_cr: BOOLEAN
		do
			body ?= part.body
			-- This loop reads data character by character.
			-- We have to stop when a boundary occurs after a CRLF.
			from
				matching_boundary := True
				last_line.wipe_out
				matched_index := 1
				read_character
			invariant
				matched_index >= 1
				not boundary_read implies matched_index <= boundary.count
				matching_boundary implies matched_index <= last_line.count + 1
			until
				end_of_input or else
				boundary_read
			loop

				-- `c' contains the current character
				c := last_character

				inspect c
				when '%R' then
					-- when a CR is encountered, we've to check for a LF to
					-- know if this is an end of line or an incidental CR
					-- (pure data)
					last_line.append_character (c)
				when '%N' then
					-- the next line could contain the boundary so we don't
					-- write the (CR)LF, but keep it in `last_line'. The
					-- CRLF is part of the boundary in that case, not of
					-- the message.
					if last_line.count > 0 and then
						last_line.item (last_line.count) = '%R' then
						-- at this point a CRLF has been read
						last_line.remove (last_line.count)
						add_cr := True
					else
						add_cr := False
					end
					body.append_string (last_line)
					last_line.wipe_out
					if add_cr then
						last_line.append_character ('%R')
					end
					last_line.append_character (c)
					matched_index := 1
					matching_boundary := True
				else
					if matching_boundary then
						match := boundary.item (matched_index) = c
						if match then
							-- Match found, advance to next character.
							last_line.append_character (c)
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							body.append_string (last_line)
							body.append_character (c)
							last_line.wipe_out
							matching_boundary := False
						end
					else
						body.append_string (last_line)
						body.append_character (c)
						last_line.wipe_out
					end
				end

				-- very expensive check
					check
						-- last_line.has_substring (boundary) implies boundary_read
					end

				read_character
			end

			-- if boundary read, skip rest of line
			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line

				check
					stop_condition: boundary_read or end_of_input
				end
		end

	read_singlepart_body_without_boundary is
			-- Read `file' until `end_of_file'. Does handle any line length.
		require
			body_contains_text: is_text_body
		local
			body: EPX_MIME_BODY_TEXT
		do
			body ?= part.body
			from
				read_character
			until
				end_of_input
			loop
				body.append_character (last_character)
				read_character
			end
		ensure
			read_everything: end_of_input
		end


invariant

	last_line_not_void: last_line /= Void
	my_date_not_void: my_date /= Void
	my_date_in_utc: my_date.is_utc_time
	my_time_not_void: my_time /= Void
	my_time_in_utc: my_time.is_utc_time

end
